#include <stddefs.h>
#include <stdlib.h>
#include <fstream.h>
#include <alloc.h>
#include <yakpcx.h>
#include "yaklib.h"
//yakpcx.c includes a simple header file definition and routines
//for loading .pcx data into icons.  It's in a separate file than
//icon.cpp just for organizational purposes.
#define OK 0
#define ERROR -1

pcxPicture * decodedPCXPic(char * filename)
{
  byte *encodedData, *decodedData;
  word c, n;
  int  byteCounter;
  int  byteData;
  word bytes, nrows, nplan;
  pcxPicture *pic = new pcxPicture;
  pcxHeader *ph;

  ph = & pic->header;
  byte * pcxData = NULL;
  pcxData = loadDosToMem(filename);
  if (pcxData == NULL)
    return NULL;
  memcpy(ph, pcxData, 128);
  bytes = ph->bpl;
  nrows = ph->y2 - ph->y1 +1;
  nplan = ph->numPlanes;
  pic->pictureData = new byte[(word)(nplan * nrows * bytes + 4)];
  *(int *)&pic->pictureData[0] = bytes;
  *(int *)&pic->pictureData[2] = nrows;
  decodedData = &pic->pictureData[4];
  encodedData = pcxData + 128;
  for (long counter = (word)(nplan*nrows*bytes); counter > 0;)
  {
    byteCounter = *(encodedData++);
    if (0xc0 == (byteCounter & 0xc0))
    {
      byteCounter &= 0x3f;
      byteData = *(encodedData++);
      while (byteCounter--)
      {
	counter--;
	*(decodedData++) = (byte)byteData;
      }
    }
    else
    {
      counter--;
      *(decodedData++) = (byte)byteCounter;
    }
  }
  delete pcxData;
  return pic;
}
